Index: /LMDZ4/trunk/libf/dyn3d/bilan_dyn.F
===================================================================
--- /LMDZ4/trunk/libf/dyn3d/bilan_dyn.F	(revision 558)
+++ /LMDZ4/trunk/libf/dyn3d/bilan_dyn.F	(revision 559)
@@ -298,4 +298,5 @@
 
 c   énergie cinétique
+      ucont(:,:,:)=0
       CALL covcont(llm,ucov,vcov,ucont,vcont)
       CALL enercin(vcov,ucov,vcont,ucont,ecin)
Index: /LMDZ4/trunk/libf/dyn3d/leapfrog.F
===================================================================
--- /LMDZ4/trunk/libf/dyn3d/leapfrog.F	(revision 558)
+++ /LMDZ4/trunk/libf/dyn3d/leapfrog.F	(revision 559)
@@ -4,5 +4,6 @@
 c
 c
-      SUBROUTINE leapfrog(ucov,vcov,teta,ps,masse,phis,nq,q,clesphy0)
+      SUBROUTINE leapfrog(ucov,vcov,teta,ps,masse,phis,nq,q,clesphy0,
+     &                    time_0)
 
 #ifdef INCA
Index: /LMDZ4/trunk/libf/phylmd/clouds_gno.F
===================================================================
--- /LMDZ4/trunk/libf/phylmd/clouds_gno.F	(revision 558)
+++ /LMDZ4/trunk/libf/phylmd/clouds_gno.F	(revision 559)
@@ -58,5 +58,7 @@
        LOGICAL lconv(klon)
 
-
+cym
+      cldf(:,:)=0.0
+      
       pi = ACOS(-1.)
       sqrtpi=sqrt(pi)
Index: /LMDZ4/trunk/libf/phylmd/concvl.F
===================================================================
--- /LMDZ4/trunk/libf/phylmd/concvl.F	(revision 558)
+++ /LMDZ4/trunk/libf/phylmd/concvl.F	(revision 559)
@@ -88,4 +88,7 @@
 c
 c
+cym
+      snow(:)=0
+      
       IF (ifrst .EQ. 0) THEN
          ifrst = 1
Index: /LMDZ4/trunk/libf/phylmd/cv3_routines.F
===================================================================
--- /LMDZ4/trunk/libf/phylmd/cv3_routines.F	(revision 558)
+++ /LMDZ4/trunk/libf/phylmd/cv3_routines.F	(revision 559)
@@ -194,5 +194,6 @@
       real pnk(len), qsnk(len), rh(len), chi(len)
       real A, B ! convect3
-
+cym
+      plcl=0.0
 c@ !-------------------------------------------------------------------
 c@ ! --- Find level of minimum moist static energy
@@ -1488,10 +1489,14 @@
             vent(i,k,j)=v(i,j)
             elij(i,k,j)=0.0
-            ment(i,k,j)=0.0
-            sij(i,k,j)=0.0
+cym            ment(i,k,j)=0.0
+cym            sij(i,k,j)=0.0
  385      continue
  390    continue
  400  continue
 
+cym
+      ment(1:ncum,1:nd,1:nd)=0.0
+      sij(1:ncum,1:nd,1:nd)=0.0
+      
 c      do k=1,ntra
 c       do j=1,nd  ! instead nlp
@@ -1620,7 +1625,10 @@
 c=====================================================================
 
-      call zilch(asum,ncum*nd)
-      call zilch(bsum,ncum*nd)
-      call zilch(csum,ncum*nd)
+cym      call zilch(asum,ncum*nd)
+cym      call zilch(bsum,ncum*nd)
+cym      call zilch(csum,ncum*nd)
+      call zilch(asum,nloc*nd)
+      call zilch(csum,nloc*nd)
+      call zilch(csum,nloc*nd)
 
       do il=1,ncum
Index: /LMDZ4/trunk/libf/phylmd/cv_driver.F
===================================================================
--- /LMDZ4/trunk/libf/phylmd/cv_driver.F	(revision 558)
+++ /LMDZ4/trunk/libf/phylmd/cv_driver.F	(revision 559)
@@ -321,4 +321,6 @@
          tp1(i,k)=0.0
          clw1(i,k)=0.0
+cym
+         clw(i,k)=0.0	 
          gz1(i,k) = 0.
 
Index: /LMDZ4/trunk/libf/phylmd/fisrtilp.F
===================================================================
--- /LMDZ4/trunk/libf/phylmd/fisrtilp.F	(revision 558)
+++ /LMDZ4/trunk/libf/phylmd/fisrtilp.F	(revision 559)
@@ -123,5 +123,7 @@
 c
       DATA appel1er /.TRUE./
-
+cym
+      zdelq=0.0
+      
       IF (appel1er) THEN
 c
Index: /LMDZ4/trunk/libf/phylmd/ini_histmth.h
===================================================================
--- /LMDZ4/trunk/libf/phylmd/ini_histmth.h	(revision 558)
+++ /LMDZ4/trunk/libf/phylmd/ini_histmth.h	(revision 559)
@@ -739,8 +739,4 @@
 c     endif
 c
-c        CALL histdef(nid_mth, "ozone", "Ozone concentration", "-",
-c    .                iim,jjmp1,nhori, klev,1,klev,nvert, 32,
-c    .                "ave(X)", zsto,zout)
-c
          if (nqmax.GE.3) THEN
          DO iq=1,nqmax-2
Index: /LMDZ4/trunk/libf/phylmd/interface_surf.F90
===================================================================
--- /LMDZ4/trunk/libf/phylmd/interface_surf.F90	(revision 558)
+++ /LMDZ4/trunk/libf/phylmd/interface_surf.F90	(revision 559)
@@ -300,4 +300,8 @@
         call abort_gcm(modname,abort_message,1)
       endif
+cym      
+      run_off=0.0
+cym
+
 !!$PB
       ALLOCATE (tmp_rriv(iim,jjm+1), stat=error)
Index: /LMDZ4/trunk/libf/phylmd/physiq.F
===================================================================
--- /LMDZ4/trunk/libf/phylmd/physiq.F	(revision 558)
+++ /LMDZ4/trunk/libf/phylmd/physiq.F	(revision 559)
@@ -625,4 +625,7 @@
       REAL sens(klon), dsens(klon) ! chaleur sensible et sa derivee
       REAL dlw(klon)    ! derivee infra rouge
+cym
+      SAVE dlw
+cym
       REAL bils(klon) ! bilan de chaleur au sol
       REAL wfbils(klon,nbsrf) ! bilan de chaleur au sol, pour chaque
@@ -824,4 +827,7 @@
 c
       INTEGER ibas_con(klon), itop_con(klon)
+cym
+      SAVE ibas_con,itop_con
+cym
       REAL rain_con(klon), rain_lsc(klon)
       REAL snow_con(klon), snow_lsc(klon)
@@ -974,4 +980,7 @@
       LOGICAL ok_ade, ok_aie    ! Apply aerosol (in)direct effects or not
       REAL bl95_b0, bl95_b1   ! Parameter in Boucher and Lohmann (1995)
+cym 
+      SAVE ok_ade, ok_aie, bl95_b0, bl95_b1
+cym
 cjq-end
 c
@@ -997,4 +1006,7 @@
       bl95_b1=0.
 !rv
+cym
+      wfbils(:,:)=0
+cym      
       modname = 'physiq'
       IF (if_ebil.ge.1) THEN
@@ -2361,4 +2373,10 @@
          CALL aeropt(pplay, paprs, t_seri, sulfate, rhcl,
      .        tau_ae, piz_ae, cg_ae, aerindex)
+cym
+      ELSE
+        tau_ae(:,:,:)=0.0
+	piz_ae(:,:,:)=0.0
+	cg_ae(:,:,:)=0.0
+cym     
       ENDIF
 