Index: LMDZ4/trunk/libf/phylmd/ini_histrac.h
===================================================================
--- LMDZ4/trunk/libf/phylmd/ini_histrac.h	(revision 616)
+++ LMDZ4/trunk/libf/phylmd/ini_histrac.h	(revision 624)
@@ -277,77 +277,77 @@
 !#ENDIF
 
-!!! Ajout Anne
-!#ifdef INCA_AER
-!! for sulfur cycle
-!         CALL histdef(nid_tra, "SO2_p_dmsoh", "SO2_p_dmsoh", "CM-3 S-1",
-!     .                iim,jjm+1,nhori, klev,1,klev,nvert, 32,
-!     .                "ave(X)", zsto,zout)
-!         CALL histdef(nid_tra, "SO2_p_dmsno3", "SO2_p_dmsno3", "CM-3 S-1",
-!     .                iim,jjm+1,nhori, klev,1,klev,nvert, 32,
-!     .                "ave(X)", zsto,zout)
-!         CALL histdef(nid_tra, "SO2_p_h2soh", "SO2_p_h2soh", "CM-3 S-1",
-!     .                iim,jjm+1,nhori, klev,1,klev,nvert, 32,
-!     .                "ave(X)", zsto,zout)
-!         CALL histdef(nid_tra, "SO2_p_dmsooh", "SO2_p_dmsooh", "CM-3 S-1",
-!     .                iim,jjm+1,nhori, klev,1,klev,nvert, 32,
-!     .                "ave(X)", zsto,zout)
-!         CALL histdef(nid_tra, "DMSO_p_dmsoh", "DMSO_p_dmsoh", "CM-3 S-1",
-!     .                iim,jjm+1,nhori, klev,1,klev,nvert, 32,
-!     .                "ave(X)", zsto,zout)
-!         CALL histdef(nid_tra, "ASMSAM_p_dmsooh", "ASMSAM_p_dmsooh", "CM-3 S-1",
-!     .                iim,jjm+1,nhori, klev,1,klev,nvert, 32,
-!     .                "ave(X)", zsto,zout)
-!         CALL histdef(nid_tra, "ASSO4M_p_so2oh", "ASSO4M_p_so2oh", "CM-3 S-1",
-!     .                iim,jjm+1,nhori, klev,1,klev,nvert, 32,
-!     .                "ave(X)", zsto,zout)
-!         CALL histdef(nid_tra, "ASSO4M_p_so2h2o2", "ASSO4M_p_h2o2","CM-3 S-1",
-!     .                iim,jjm+1,nhori, klev,1,klev,nvert, 32,
-!     .                "ave(X)", zsto,zout)
-!         CALL histdef(nid_tra, "ASSO4M_p_so2o3", "ASSO4M_p_so2o3", "CM-3 S-1",
-!     .                iim,jjm+1,nhori, klev,1,klev,nvert, 32,
-!     .                "ave(X)", zsto,zout)
-!
-!         CALL histdef(nid_tra, "Wet3D_SO2", "Wet3D_SO2",
-!     .           "kg/m2/s", iim,jjm+1,nhori, klev,1,klev,nvert, 32,
-!     .           "ave(X)", zsto,zout)
-!         CALL histdef(nid_tra, "Wet3D_DMS", "Wet3D_DMS",
-!     .           "kg/m2/s", iim,jjm+1,nhori, klev,1,klev,nvert, 32,
-!     .           "ave(X)", zsto,zout)
-!         CALL histdef(nid_tra, "Wet3D_HNO3", "Wet3D_HNO3",
-!     .           "kg/m2/s", iim,jjm+1,nhori, klev,1,klev,nvert, 32,
-!     .           "ave(X)", zsto,zout)
-!         CALL histdef(nid_tra, "Wet3D_H2O2", "Wet3D_H2O2",
-!     .           "kg/m2/s", iim,jjm+1,nhori, klev,1,klev,nvert, 32,
-!     .           "ave(X)", zsto,zout)
-!
-!         CALL histdef(nid_tra, "PH_HIST", "pH over physics time step", "1",
-!     .                iim,jjm+1,nhori, klev,1,klev,nvert, 32,
-!     .                "ave(X)", zsto,zout)
-!#endif
-!
-!#ifdef INCA_NMHC
-!         CALL histdef(nid_tra, "CO2_basprod", "CO2_basprod", "CM-3 S-1",
-!     .                iim,jjm+1,nhori, klev,1,klev,nvert, 32,
-!     .                "ave(X)", zsto,zout)
-!         CALL histdef(nid_tra, "CO2_nmhcprod", "CO2_nmhcprod", "CM-3 S-1",
-!     .                iim,jjm+1,nhori, klev,1,klev,nvert, 32,
-!     .                "ave(X)", zsto,zout)
-!         CALL histdef(nid_tra, "CO2_radicalprod", "CO2_radicalprod", "CM-3 S-1",
-!     .                iim,jjm+1,nhori, klev,1,klev,nvert, 32,
-!     .                "ave(X)", zsto,zout)
-!         CALL histdef(nid_tra, "HNO3_prod", "HNO3_prod", "CM-3 S-1",
-!     .                iim,jjm+1,nhori, klev,1,klev,nvert, 32,
-!     .                "ave(X)", zsto,zout)
-!         CALL histdef(nid_tra, "HNO3_loss", "HNO3_loss", "CM-3 S-1",
-!     .                iim,jjm+1,nhori, klev,1,klev,nvert, 32,
-!     .                "ave(X)", zsto,zout)
-!         CALL histdef(nid_tra, "CO_prod", "CO_prod", "CM-3 S-1",
-!     .                iim,jjm+1,nhori, klev,1,klev,nvert, 32,
-!     .                "ave(X)", zsto,zout)
-!         CALL histdef(nid_tra, "CO_loss", "CO_loss", "CM-3 S-1",
-!     .                iim,jjm+1,nhori, klev,1,klev,nvert, 32,
-!     .                "ave(X)", zsto,zout)
-!#endif
-!! Fin ajout Anne
+!! Ajout Anne
+#ifdef INCA_AER
+! for sulfur cycle
+         CALL histdef(nid_tra, "SO2_p_dmsoh", "SO2_p_dmsoh", "CM-3 S-1",
+     .                iim,jjm+1,nhori, klev,1,klev,nvert, 32,
+     .                "ave(X)", zsto,zout)
+         CALL histdef(nid_tra, "SO2_p_dmsno3", "SO2_p_dmsno3", "CM-3 S-1",
+     .                iim,jjm+1,nhori, klev,1,klev,nvert, 32,
+     .                "ave(X)", zsto,zout)
+         CALL histdef(nid_tra, "SO2_p_h2soh", "SO2_p_h2soh", "CM-3 S-1",
+     .                iim,jjm+1,nhori, klev,1,klev,nvert, 32,
+     .                "ave(X)", zsto,zout)
+         CALL histdef(nid_tra, "SO2_p_dmsooh", "SO2_p_dmsooh", "CM-3 S-1",
+     .                iim,jjm+1,nhori, klev,1,klev,nvert, 32,
+     .                "ave(X)", zsto,zout)
+         CALL histdef(nid_tra, "DMSO_p_dmsoh", "DMSO_p_dmsoh", "CM-3 S-1",
+     .                iim,jjm+1,nhori, klev,1,klev,nvert, 32,
+     .                "ave(X)", zsto,zout)
+         CALL histdef(nid_tra, "ASMSAM_p_dmsooh", "ASMSAM_p_dmsooh", "CM-3 S-1",
+     .                iim,jjm+1,nhori, klev,1,klev,nvert, 32,
+     .                "ave(X)", zsto,zout)
+         CALL histdef(nid_tra, "ASSO4M_p_so2oh", "ASSO4M_p_so2oh", "CM-3 S-1",
+     .                iim,jjm+1,nhori, klev,1,klev,nvert, 32,
+     .                "ave(X)", zsto,zout)
+         CALL histdef(nid_tra, "ASSO4M_p_so2h2o2", "ASSO4M_p_h2o2","CM-3 S-1",
+     .                iim,jjm+1,nhori, klev,1,klev,nvert, 32,
+     .                "ave(X)", zsto,zout)
+         CALL histdef(nid_tra, "ASSO4M_p_so2o3", "ASSO4M_p_so2o3", "CM-3 S-1",
+     .                iim,jjm+1,nhori, klev,1,klev,nvert, 32,
+     .                "ave(X)", zsto,zout)
+
+         CALL histdef(nid_tra, "Wet3D_SO2", "Wet3D_SO2",
+     .           "kg/m2/s", iim,jjm+1,nhori, klev,1,klev,nvert, 32,
+     .           "ave(X)", zsto,zout)
+         CALL histdef(nid_tra, "Wet3D_DMS", "Wet3D_DMS",
+     .           "kg/m2/s", iim,jjm+1,nhori, klev,1,klev,nvert, 32,
+     .           "ave(X)", zsto,zout)
+         CALL histdef(nid_tra, "Wet3D_HNO3", "Wet3D_HNO3",
+     .           "kg/m2/s", iim,jjm+1,nhori, klev,1,klev,nvert, 32,
+     .           "ave(X)", zsto,zout)
+         CALL histdef(nid_tra, "Wet3D_H2O2", "Wet3D_H2O2",
+     .           "kg/m2/s", iim,jjm+1,nhori, klev,1,klev,nvert, 32,
+     .           "ave(X)", zsto,zout)
+
+         CALL histdef(nid_tra, "PH_HIST", "pH over physics time step", "1",
+     .                iim,jjm+1,nhori, klev,1,klev,nvert, 32,
+     .                "ave(X)", zsto,zout)
+#endif
+
+#ifdef INCA_NMHC
+         CALL histdef(nid_tra, "CO2_basprod", "CO2_basprod", "CM-3 S-1",
+     .                iim,jjm+1,nhori, klev,1,klev,nvert, 32,
+     .                "ave(X)", zsto,zout)
+         CALL histdef(nid_tra, "CO2_nmhcprod", "CO2_nmhcprod", "CM-3 S-1",
+     .                iim,jjm+1,nhori, klev,1,klev,nvert, 32,
+     .                "ave(X)", zsto,zout)
+         CALL histdef(nid_tra, "CO2_radicalprod", "CO2_radicalprod", "CM-3 S-1",
+     .                iim,jjm+1,nhori, klev,1,klev,nvert, 32,
+     .                "ave(X)", zsto,zout)
+         CALL histdef(nid_tra, "HNO3_prod", "HNO3_prod", "CM-3 S-1",
+     .                iim,jjm+1,nhori, klev,1,klev,nvert, 32,
+     .                "ave(X)", zsto,zout)
+         CALL histdef(nid_tra, "HNO3_loss", "HNO3_loss", "CM-3 S-1",
+     .                iim,jjm+1,nhori, klev,1,klev,nvert, 32,
+     .                "ave(X)", zsto,zout)
+         CALL histdef(nid_tra, "CO_prod", "CO_prod", "CM-3 S-1",
+     .                iim,jjm+1,nhori, klev,1,klev,nvert, 32,
+     .                "ave(X)", zsto,zout)
+         CALL histdef(nid_tra, "CO_loss", "CO_loss", "CM-3 S-1",
+     .                iim,jjm+1,nhori, klev,1,klev,nvert, 32,
+     .                "ave(X)", zsto,zout)
+#endif
+! Fin ajout Anne
 #else
          CALL histdef(nid_tra, "pyu1", "Vent niv 1", "-",